%letterex
clear all;
%load data
D = [1 0 0 0 1 1 0 1 1 0 1 0 1 1 0 1 0 1 1 0 1 0 0 0 1];
X = reshape(D, 5, 5);
subplot(6,2,1);
imshow(X');
title('First Memory');
set(gcf,'Position', [10 50 400 600]) %set(gcf,'Position', [10 211 416 730])
J = [0 0 0 0 0 1 1 1 0 1 1 1 1 0 1 0 1 1 0 1 0 0 0 0 1];
X = reshape(J, 5, 5);
subplot(6,2,2);
imshow(X');
title('Second Memory');
C = [1 0 0 0 0 0 1 1 1 1 0 1 1 1 1 0 1 1 1 1 1 0 0 0 0];
X = reshape(C, 5, 5);
subplot(6,2,3);
imshow(X');
title('Third Memory');
M = [0 1 1 1 0 0 0 1 0 0 0 1 0 1 0 0 1 1 1 0 0 1 1 1 0];
X = reshape(M, 5, 5);
subplot(6,2,4);
imshow(X');
title('Fourth Memory');
%create data matrix
data(1,:) = D;
data(2,:) = J;
data(3,:) = C;
data(4,:) = M;

n = 25; %number of data points in each picture
%make all 0s in data into -1s
datamones = data - ones(size(data));
newdata = data + datamones;

%make weights matrix (n x n)
w = zeros(n,n);
for i = 1:n
    for j = 1:n
        if i == j
            w(i,j) = 0;
        else
            w(i,j) = newdata(:,i)'*newdata(:,j);
        end
    end
end
%initial states (with errors)
Xerr(5,:) = [1 1 -1 -1 1 1 -1 1 1 1 1 -1 1 1 -1 1 -1 1 1 -1 1 -1 -1 -1 1];
Xerr(7,:) = [-1 -1 -1 -1 -1 -1 1 1 1 -1 -1 1 -1 1 1 -1 1 1 -1 1 1 -1 -1 -1 -1];
Xerr(9,:) = [1 1 1 1 -1 1 -1 1 -1 1 1 1 1 1 -1 -1 -1 1 1 -1 -1 1 1 -1 1];
Xerr(11,:)= [1 -1 1 -1 1 -1 1 1 1 -1 1 -1 1 1 1 -1 -1 -1 1 1 1 -1 -1 1 -1];
for h = 5:2:11
    Xerror = Xerr(h,:);
    Xtest = Xerror;
    X_new = Xtest;
    X_old = ones(size(Xtest));
    count = 0;
    while X_old*X_new'~=length(Xtest)
        count = count +1;
        % step 3: Asynchonous update
        if count == 50
            break
        else
            X_old = X_new; % previous new is now old
            X_new = AUpdate(X_old,w);
        end
    end
    %plot initial state and the stable state it converges to
    X1 = reshape(Xerr(h,:), 5, 5);
    subplot(6,2,h);
    imshow(X1');
    title(sprintf('Initial State (%d errors)',h-3));
    X = reshape(X_new, 5, 5);
    subplot(6,2,h+1);
    imshow(X');
    title('Stable State');
end
